lwl = 0;
lwr = 0;
lwt = 0;
lwb = 0;
doDebug = 0;

function CalculateNewLocation(r, c)
	local x = xyWindowSize[0] - 2 - ((c-1) * 15);
	local y = 2 + ((r-1) * 15);
	return x,y
end

function setWaitSpot(x0, y0)
	setWaitSpot_x = x0;
	setWaitSpot_y = y0;
	setWaitSpot_px = srReadPixel(x0, y0);
end

function drag(x0, y0, x1, y1)
	lsPrintln("Dragging from " .. x0 .. "," .. y0 .. " to " .. x1 .. "," .. y1);
	local oX,oY = srMousePos();
	srSetMousePos(x0, y0);
	setWaitSpot (x1, y1);
	srMouseDown(x0, y0, 0);
	srSetMousePos(x1, y1);
	lsSleep(delay);
	srMouseUp(x0, y0, 0);
	srSetMousePos(oX,oY);
	lsSleep(delay);
end

function ClickMouseNoMove(x, y)
	local oX,oY = srMousePos();
	srMouseUp(oX,oY,0);
	srSetMousePos(x, y);
	srClickMouseNoMove(x, y);
	srSetMousePos(oX,oY);
end

function WaitForImage(imageName, t, e)
	lsPrintln("Looking for " .. imageName);
	if t == nil then
		t = 2000;
	end
	if e == nil then
		e = 0;
	end
	while 1 do
		checkBreak();
		srReadScreen();
		btn = findAllImages(imageName);
		if #btn > 0 then
			break;
		end
		lsSleep(100);
		t = t - 100;
		if t < 0 then
			if e == 1 then
				error("Timeout Occured while waiting for image.");
			else
				lsPrintln("Timeout Occured while waiting for image.");
				break;
			end
		end
	end
	if #btn > 0 then
		lsPrintln(imageName .. " found.");
	else
		lsPrintln(imageName .. " not found.");
	end
	return btn;
end

function GetWindowBorders(x, y)
	local l = x;
	local r = x;
	local t = y;
	local b = y;
	local ol = x;
	local ot = y
	srReadScreen();
	while 1 do
		checkBreak();
		p = srReadPixel(l, ot);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		l = l - 1;
		if l < 1 then
			l = 1
			break;
		end
	end
	
	while 1 do
		checkBreak();
		p = srReadPixel(r, ot);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		r = r + 1;
		if r > xyWindowSize[0]-1 then
			r = xyWindowSize[0]-1;
			break;
		end
	end
	
	while 1 do
		checkBreak();
		p = srReadPixel(ol, t);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		t = t - 1;
		if t < 1 then
			t = 1;
			break;
		end;
	end
	
	while 1 do
		checkBreak();
		p = srReadPixel(ol, b);
		if p == 0x72502EFF or p == 0x714f2eff or p == 0x6f4e2dff or p == 0x785431ff then
			break;
		end
		b = b + 1;
		if b > xyWindowSize[1] - 1 then
			b = xyWindowSize[1]-1;
			break;
		end
	end
	
	l = l - 1;
	r = r + 1;
	t = t - 1;
	b = b + 1;
	return l,r,t,b;
end

function GetCoordinates()
	lsPrintln("Start GetCoordinates");
	srReadScreen();
	local st = srFindImageInRange("colon.png", lwl, lwt, lwr-lwl, lwb-lwt);
	local xCoord = ocrNumber(st[0] + 7, st[1]);
	local uv = srFindImageInRange("comma.png", st[0], st[1], lwr-st[0], lwb-st[1]);
	local yCoord = ocrNumber(uv[0] + 8, uv[1]);
	lsPrintln("End GetCoordinates");
	
	return xCoord, yCoord
end

function ocrNumber(x, y)
	lsPrintln("Start ocrNumber");
	-- find first number
	local digit=nil;
	local offset=0;
	while (not digit) and (offset < 10) do
		for i=0, 9 do
			local pos = srFindImageInRange(i .. ".png", x, y, 6, 9, tol);
			if pos then
				digit=i;
				break;
			end
		end
		if not digit then
			x = x+1;
			offset = offset + 1;
		end
	end
	if (offset > 0) then
		lsPrintln("Perf warning: OCR non-0 offset of " .. offset);
	end
	local ret = digit;
	while 1 do
		digit = nil;
		x = x + 7;
		for i=0, 9 do
			local pos = srFindImageInRange(i .. ".png", x, y, 6, 9, tol);
			if pos then
				digit=i;
				break;
			end
		end
		if digit then
			ret = ret * 10 + digit;
		else
			break;
		end
	end
	lsPrintln("End ocrNumber");
	return ret;
end

function debug(message)
	if doDebug then
		local f = io.open("debug.log","a+");
		f:write(message .. "\n");
		f:close();
	end
end