--
--
--

loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();
loadfile("luaScripts/Library.inc")();

-- Set this to the ingredient you wish to use for "filling up" the Pigment Laboratory to quantity 10 between each test.
-- 1=Cabbage Juice, 2=Carrots, 3=Clay, 4=Dead Tongue, 5=Toad Skin, 6=Earth Light, 7=Red Sand
-- 8=Lead, 9=Silver Powder, 10=Iron, 11=Copper

fillerIngredient = 1;

-- Please don't change anything below this line.

windowL = 0;
windowT = 0;
windowR = 0;
windowB = 0;

barLeft = 0;
barRight = 0;
colorBar = { 0, 0, 0 }
ingredButtonX = 0;
ingredButtonY = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
ingredients = { { "Cabbage", 128, 64, 144, 3, -1 }, { "Carrot", 224, 112, 32, 2, -1 }, { "Clay", 128, 96, 32, 4, 50 }, { "DeadTongue", 112, 64, 64, 20, 2 }, { "ToadSkin", 48, 96, 48, 20, 2 }, { "EarthLight", 128, 240, 224, 30, 1 }, { "RedSand", 144, 16, 24, 1, -1 }, { "Lead", 80, 80, 96, 2, 50 }, { "Silver", 16, 16, 32, 1, 50 }, { "Iron", 96, 48, 32, 2, 50 }, { "Copper", 64, 192, 192, 2, 50 }, { "Sulfur", 0, 0, 0, 2, 1 }, { "Potash", 0, 0, 0, 3, 1 }, { "Lime", 0, 0, 0, 2, 1 }, { "Saltpeter", 0, 0, 0, 2, 1 } }
ingredientCount = 15;

reactionPairs = { { "Cabbage", "DeadTongue", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Cabbage", "EarthLight", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Cabbage", "RedSand", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Cabbage", "Iron", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Cabbage", "Copper", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Cabbage", "Potash", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Carrot", "DeadTongue", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Carrot", "ToadSkin", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Carrot", "RedSand", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Carrot", "Lead", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Carrot", "Potash", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Carrot", "Lime", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "ToadSkin", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "EarthLight", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "Lead", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "Silver", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "Copper", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "Sulfur", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Clay", "Saltpeter", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "ToadSkin", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "RedSand", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "Lead", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "Iron", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "Copper", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "Potash", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "DeadTongue", "Lime", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "ToadSkin", "Lead", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "ToadSkin", "Copper", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "ToadSkin", "Potash", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "ToadSkin", "Lime", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "EarthLight", "RedSand", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "EarthLight", "Lead", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "EarthLight", "Iron", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "EarthLight", "Sulfur", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "EarthLight", "Potash", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "RedSand", "Silver", "R", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Lead", "Silver", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Lead", "Iron", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Lead", "Copper", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Lead", "Saltpeter", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Silver", "Iron", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Silver", "Copper", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Silver", "Saltpeter", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Iron", "Sulfur", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Iron", "Saltpeter", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Copper", "Sulfur", "W", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Copper", "Saltpeter", "B", { 0, 0, 0 }, { 0, 0, 0 }, 0 }, { "Sulfur", "Potash", "G", { 0, 0, 0 }, { 0, 0, 0 }, 0 } }
reactionPairCount = 48;

function loadIngredients(c, reverse, a)
	if reverse == nil then
		reverse = 0;
	end
	if a == nil then
		a = 0;
	end
	if reverse == 0 then
		firstIng = ingredientNumber(reactionPairs[c][1]);
		secIng = ingredientNumber(reactionPairs[c][2]);
	else
		firstIng = ingredientNumber(reactionPairs[c][2]);
		secIng = ingredientNumber(reactionPairs[c][1]);
	end

	srClickMouseNoMove(ingredButtonX, ingredButtonY[firstIng]);
	lsSleep(200);
	srClickMouseNoMove(ingredButtonX, ingredButtonY[secIng]);
	lsSleep(200);
	if a > 0 then
		debug("Adding 3rd ingredient: " .. ingredients[a][1]);
		srClickMouseNoMove(ingredButtonX, ingredButtonY[a]);
		lsSleep(200);
	end
end

function readResults()
	srReadScreen();
	local bit = require("bit");
	local band, rshift = bit.band, bit.rshift;
	local r, g, b
	local c, ce
	
	c = srReadPixel(barLeft+3, colorBar[1]);
	c2 = srReadPixel(barRight-3, colorBar[1]);
	if (rshift(band(c, 0xFF000000),24)) > 250 and (rshift(band(c2, 0xFF000000),24)) < 250 then
		for i=barLeft+3, barRight-3 do
			ce = srReadPixel(i, colorBar[1])
			if (rshift(band(ce, 0xFF000000),24)) < 250 then
				r = round(((i-1)-barLeft)*255/260);
				break;
			end
		end
	else
		r = 0;
	end
	
	c = srReadPixel(barLeft+3, colorBar[2]);
	c2 = srReadPixel(barRight-3, colorBar[2]);
	if (rshift(band(c, 0x00FF0000),16)) > 250 and (rshift(band(c2, 0x00FF0000),16)) < 250 then
		for i=barLeft+3, barRight-3 do
			ce = srReadPixel(i, colorBar[2])
			if (rshift(band(ce, 0x00FF0000),16)) < 250 then
				g = round(((i-1)-barLeft)*255/260);
				break;
			end
		end
	else
		g = 0;
	end

	local c = srReadPixel(barLeft+3, colorBar[3]);
	c2 = srReadPixel(barRight-3, colorBar[3]);
	if (rshift(band(c, 0x0000FF00),8)) > 250 and (rshift(band(c2, 0x0000FF00),8)) < 250 then
		for i=barLeft+3, barRight-3 do
			ce = srReadPixel(i, colorBar[3])
			if (rshift(band(ce, 0x0000FF00),8)) < 250 then
				b = round(((i-1)-barLeft)*255/260);
				break;
			end
		end
	else
		b = 0;
	end
	
	return r,g,b;
end

function getSkew(c, r, g, b, i)
	lsPrintln("Get Skew - c: " .. c .. " rgb: " .. r .. "," .. g .. "," .. b .. " i: " .. i);
	debug("Get Skew - c: " .. c .. " rgb: " .. r .. "," .. g .. "," .. b .. " i: " .. i);
	local oR = 0
	local oG = 0
	local oB = 0;
	
	oR = oR + ingredients[ingredientNumber(reactionPairs[c][1])][2];
	oG = oG + ingredients[ingredientNumber(reactionPairs[c][1])][3];
	oB = oB + ingredients[ingredientNumber(reactionPairs[c][1])][4];

	oR = oR + ingredients[ingredientNumber(reactionPairs[c][2])][2];
	oG = oG + ingredients[ingredientNumber(reactionPairs[c][2])][3];
	oB = oB + ingredients[ingredientNumber(reactionPairs[c][2])][4];
	
	if i > 2 then
		oR = oR + ingredients[reactionPairs[c][6]][2];
		oG = oG + ingredients[reactionPairs[c][6]][3];
		oB = oB + ingredients[reactionPairs[c][6]][4];
	end
	
	if ingredientNumber(reactionPairs[c][1]) > 11 then
		i = i - 1;
	end
	if ingredientNumber(reactionPairs[c][2]) > 11 then
		i = i - 1;
	end
	if i == 0 then
		i = 1;
	end
	debug("r: " .. r .. " g: " .. g .. " b: " .. b .. " - or: " .. oR .. " og: " .. oG .. " ob: " .. oB); 
	oR = math.floor(oR/i);
	oG = math.floor(oG/i);
	oB = math.floor(oB/i);
	debug("r: " .. r .. " g: " .. g .. " b: " .. b .. " - or: " .. oR .. " og: " .. oG .. " ob: " .. oB); 
	return r-oR, g-oG, b-oB;
end

function emptyLab()
	local x = ingredButtonX;
	local y = ingredButtonY[fillerIngredient];
	
	while 1 do
		checkBreak();
		srReadScreen();
		local conc = srFindImageInRange("Concentration10.png", windowL, windowT, windowR-windowL, windowB-windowT);
		if conc == nil then
			srClickMouseNoMove(x,y);
			lsSleep(400);
		else
			break;
		end
	end
	local btn = srFindImageInRange("TakeThe.png", windowL, windowT, windowR-windowL, windowB-windowT);
	srClickMouseNoMove(btn[0], btn[1]);
	lsSleep(200);
end

function storeReaction(c, r, g, b, rr, rg, rb)
	reactionPairs[c][4][1] = r;
	reactionPairs[c][4][2] = g;
	reactionPairs[c][4][3] = b;
	reactionPairs[c][5][1] = rr;
	reactionPairs[c][5][2] = rg;
	reactionPairs[c][5][3] = rb;
end

function saveReactions()
	local f = io.open("reactions.txt", "w+");
	f:write("// Reactions are in the form\n");
	f:write("// Ingredient 1 | Ingredient 2 | Color (R, G, B, or W) | Ing1->Ing2 reaction | Ing2->Ing1 reaction\n");
	f:write("//\n");
	f:write("// Make sure to only add 1 line for both the A->B reaction and the B->A reaction\n");
	f:write("//\n");
	f:write("// This reaction list is not complete; you must fill in your own reactions.\n");
	f:write("// If you don't know your reactions for a particular ingredient, make sure to disable\n");
	f:write("// that ingredient before running the analysis.\n");
	f:write("\n");
	
	local r1, r2;
	
	for i=1, ingredientCount do
		for j=1, reactionPairCount do
		
			if reactionPairs[j][1] == ingredients[i][1] then
				if (reactionPairs[j][3] == "R" or reactionPairs[j][3] == "W") then
					r1 = reactionPairs[j][4][1];
					r2 = reactionPairs[j][5][1];
				end
				if (reactionPairs[j][3] == "G") then
					r1 = reactionPairs[j][4][2];
					r2 = reactionPairs[j][5][2];
				end
				if (reactionPairs[j][3] == "B") then
					r1 = reactionPairs[j][4][3];
					r2 = reactionPairs[j][5][3];
				end
			
				f:write(reactionPairs[j][1] .. " | " .. reactionPairs[j][2] .. " | " .. reactionPairs[j][3] .. " | " .. r1 .. " | " .. r2 .. "\n");
			end	
		end
		f:write("\n");
	end
	f:close();
	
end

function round(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

function ingredientNumber(ingredientName)
	local num = 0
	for c=1, ingredientCount do
		if ingredients[c][1] == ingredientName then
			num = c;
			break;
		end
	end
	return num;
end

function findNextNonReactive(ingred, react)
	debug("findNextNonReactive " .. ingred .. "," .. react);
	local i = 0;
	local found = 0;
	ingred1 = ingredients[ingred][1];
	while found==0 and react < 12 do
		local ingred2 = ingredients[react][1];
		for i = 1, reactionPairCount do
			--debug("Comparing " .. reactionPairs[i][1] .. " with " .. ingred1 .. " and " .. reactionPairs[i][2] .. " with " .. ingred2);
			if (reactionPairs[i][1] == ingred1 and reactionPairs[i][2] == ingred2) or (reactionPairs[i][1] == ingred2 and reactionPairs[i][2] == ingred1) then
				found = 1;
				break;
			end
		end
		if found == 0 then
			break;
		end
		found = 0;
		react = react + 1;
	end
	return react;
end

function doit()
	askForWindow("-- Script written by Walter K. Zydhek\n\nPlease avoid using the mouse while macro is working, but feel free to use F9/F10 and Enter for chatting.");

	srReadScreen();
	local lab = srFindImage("PigmentLaboratory.png");
	if (lab == nil) then
		error("Could not locate Pigment Laboratory Window");
	end
	
	local l,r,t,b = GetWindowBorders(lab[0], lab[1]);
	windowL = l;
	windowR = r;
	windowT = t;
	windowB = b;
	
	local ingred = srFindImageInRange("Ingredient.png", l, t, r-l, b-t);
	
	barLeft = l + 9;
	barRight = r - 9;
	colorBar[1] = ingred[1] - 36;
	colorBar[2] = ingred[1] - 26;
	colorBar[3] = ingred[1] - 16;
	ingredButtonX = ingred[0] + 7;
	for b = 1, 15 do
		ingredButtonY[b] = ingred[1]+25 + ((b-1) * 18);
	end

	local r = 0;
	local g = 0;
	local b = 0;

	--lsPrintln(r .. "," .. g .. "," .. b);
	--sleepWithStatus(1000000);
	  for c = 1, reactionPairCount do
	--for c = 11, 11 do
		local startEmpty = 1;	
		statusScreen(reactionPairs[c][1] .. " -> " .. reactionPairs[c][2]);
		lsPrintln(reactionPairs[c][1] .. " -> " .. reactionPairs[c][2]);
		debug(reactionPairs[c][1] .. " -> " .. reactionPairs[c][2]);
		k = 0;
		r = 0;
		g = 0;
		b = 0;
		while 1 do 
			r = 0;
			g = 0;
			b = 0;
			if (startEmpty == 0) then
				emptyLab();
			else 
				startEmpty = 0;
			end
			loadIngredients(c, 0, k)
			r, g, b = readResults();
			lsPrintln(reactionPairs[c][1] .. " -> " .. reactionPairs[c][2] .. ": " .. r .. "," .. g .. "," .. b .. " - " .. k)
			debug(reactionPairs[c][1] .. " -> " .. reactionPairs[c][2] .. ": " .. r .. "," .. g .. "," .. b .. " - " .. k)
			if (r > 0 and g > 0 and b > 0 and r < 255 and g < 255 and b < 255) or k > 11 then
				break;
			end
			k = k + 1
			k = findNextNonReactive(ingredientNumber(reactionPairs[c][2]),k);
		end
		local i = 0;
		if k == 0 then
			i = 2;
		else
			reactionPairs[c][6] = k;
			i = 3;
		end
		local diffR, diffG, diffB = getSkew(c, r, g, b, i);
		debug("Skew: " .. diffR .. "," .. diffG .. "," .. diffB);
		emptyLab();
		
		local startEmpty = 1;	
		statusScreen(reactionPairs[c][2] .. " -> " .. reactionPairs[c][1]);
		lsPrintln(reactionPairs[c][2] .. " -> " .. reactionPairs[c][1]);
		debug(reactionPairs[c][2] .. " -> " .. reactionPairs[c][1]);
		k = 0;
		r = 0;
		g = 0;
		b = 0;
		while 1 do
			r = 0;
			g = 0;
			b = 0;
			if (startEmpty == 0) then
				emptyLab();
			else 
				startEmpty = 0;
			end
			loadIngredients(c, 1, k)
			r, g, b = readResults();
			lsPrintln(reactionPairs[c][2] .. " -> " .. reactionPairs[c][1] .. ": " .. r .. "," .. g .. "," .. b .. " - " .. k)
			debug(reactionPairs[c][2] .. " -> " .. reactionPairs[c][1] .. ": " .. r .. "," .. g .. "," .. b .. " - " .. k)
			if (r > 0 and g > 0 and b > 0 and r < 255 and g < 255 and b < 255) or k > 11 then
				break;
			end
			k = k + 1
			k = findNextNonReactive(ingredientNumber(reactionPairs[c][2]),k);
		end
		local i = 0;
		if k == 0 then
			i = 2;
		else
			reactionPairs[c][6] = k;
			i = 3;
		end
		local rdiffR, rdiffG, rdiffB = getSkew(c, r, g, b, i);
		debug("Skew: " .. rdiffR .. "," .. rdiffG .. "," .. rdiffB);
		
		emptyLab();

		storeReaction(c, diffR, diffG, diffB, rdiffR, rdiffG, rdiffB);
	end

	statusScreen("Saving Results");
	saveReactions();	
	sleepWithStatus(10000);

end
